<?php

namespace XenGenTr\XGTStyleV5;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

    /**
     * ----------------
     *     Kuruluma bala 
     * ----------------
     */
    public function installStep1()
    {
        $sm = $this->schemaManager();

        $sm->alterTable('xf_node', function(Alter $table)
        {
            $table->addColumn('xgt_renk1', 'mediumblob')->nullable();
            $table->addColumn('xgt_renk2', 'mediumblob')->nullable();
            $table->addColumn('xgt_renk3', 'mediumblob')->nullable();
            $table->addColumn('xgt_renk4', 'mediumblob')->nullable();
        });

     }
	  
    public function installStep2()
    {
        $this->createWidget('xgtsv5_footer_istatistik', 'xgtSv5Footeristatistik_wd', [
            'positions' => []

        ]);

        $this->createWidget('xgtsv5_footer_tepki_lideri_konular', 'xgt5TepkiLideriKonular_wd', [
            'positions' => []

        ]);

        $this->createWidget('xgtsv5_footer_tepki_lideri_uyeler', 'xgt5TepkiLideriUyeler_wd', [
            'positions' => []

        ]);

        $this->createWidget('xgtsv5_kullanici_paneli', 'xgt5KullaniciPaneli_wd', [
            'positions' => []

        ]);
    }

    /**
     * ----------------
     *     Temizlige basla :)
     * ----------------
     */

    public function uninstallStep1()
    {
        $this->deleteWidget('xgtSv5Footeristatistik_wd');
        $this->deleteWidget('xgt5TepkiLideriKonular_wd');
        $this->deleteWidget('xgt5TepkiLideriKonular_wd');
    }

	public function uninstallStep2()
	{
		$sm = $this->schemaManager();
		
		$sm->alterTable('xf_node', function(Alter $table)
		{
			$table->dropColumns([
				'xgt_renk1',
				'xgt_renk2',
				'xgt_renk3',
                'xgt_renk4',
			]);
		});		
	}
}